#include <iostream>
#include <sstream>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>
#include <map>

#define INF (1 << 30)

void dfs(std::vector<std::set<unsigned> >* G,
	 std::vector<unsigned>* d,
	 std::vector<unsigned>* l,
	 std::vector<unsigned>* p,
	 unsigned u, unsigned* time,
	 std::vector<std::pair<unsigned, unsigned> >* st,
	 std::vector<std::pair<unsigned, std::vector<std::pair<unsigned, unsigned>>>>* CC) {
  *time += 1;
  (*d)[u] = *time;
  (*l)[u] = *time;
  unsigned cnt = 0;

  for (auto v : (*G)[u]) {
    if ((*d)[v] == INF) {
      ++cnt;
      (*p)[v] = u;
      st->push_back(std::make_pair(u, v));
      dfs(G, d, l, p, v, time, st, CC);
      (*l)[u] = std::min((*l)[u], (*l)[v]);
      std::vector<std::pair<unsigned, unsigned> > e;
      if (((*d)[u] == 1 && cnt > 1) || ((*d)[u] != INF && (*l)[v] >= (*d)[u])) {
	while (st->back().first != u || st->back().second != v) {
	  // std::cout << st->back().first+1 << "--" << st->back().second+1 << " ";
	  e.push_back(std::make_pair(st->back().first, st->back().second));
	  st->pop_back();
	}
	// std::cout << st->back().first+1 << "--" << st->back().second+1 << " ";
	e.push_back(std::make_pair(st->back().first, st->back().second));
	st->pop_back();
	// std::cout << std::endl;
	CC->push_back(std::make_pair(u, e));
	++cnt;
      }
    } else if (v != (*p)[u]) {
      (*l)[u] = std::min((*l)[u], (*d)[v]);
      if ((*d)[v] < (*d)[u]) st->push_back(std::make_pair(u, v));
    }
  }
  *time += 1;
}

std::vector<std::pair<unsigned, std::vector<std::pair<unsigned, unsigned> > > > bcc(std::vector<std::set<unsigned> >* G, unsigned s) {
  unsigned const n = G->size();
  std::vector<unsigned> discovered(n, INF), low(n, INF), parent(n, INF);
  unsigned time = 0;
  std::vector<std::pair<unsigned, unsigned> > st;
  std::vector<std::pair<unsigned, std::vector<std::pair<unsigned, unsigned>>>> CC;

  dfs(G, &discovered, &low, &parent, s, &time, &st, &CC);
  // for (unsigned u = 0; u < n; ++u) {
  //   if (discovered[u] == INF && (*G)[u].size() > 0)
  //     dfs(G, &discovered, &low, &parent, u, &time, &st, &CC);
  // }

  return CC;
}

void contract(unsigned u, std::vector<std::set<std::pair<unsigned, unsigned> >  > *G, unsigned s, unsigned t) {
  auto it = (*G)[u].begin();
  std::pair p1 = std::make_pair((*it).first, (*it).second);
  it++;
  std::pair p2 = std::make_pair((*it).first, (*it).second);
  if (p1.first == s || p1.first == t || p2.first == s || p2.first == t) return;
  (*G)[u].erase(p1);
  (*G)[u].erase(p2);
  unsigned w = p1.second + p2.second;

  std::pair q1 = std::make_pair(u, p1.second);
  std::pair q2 = std::make_pair(u, p2.second);
  (*G)[p1.first].erase(q1);
  (*G)[p2.first].erase(q2);

  std::pair r1 = std::make_pair(p2.first, w);
  std::pair r2 = std::make_pair(p1.first, w);
  (*G)[p1.first].insert(r1);
  (*G)[p2.first].insert(r2);
  // std::cout << u+1 << std::endl;
}
	      

void remove_vertex(unsigned u, std::vector<std::set<unsigned> > *G, unsigned s, unsigned t) {
  auto it = (*G)[u].begin();
  if (it != (*G)[u].end() && *it != s && *it != t) {
    (*G)[*it].erase(u);
    (*G)[u].erase(*it);
    if ((*G)[*it].size() == 1) remove_vertex(*it, G, s, t);
  }
}

std::set<unsigned> shortest_path(std::vector<std::set<unsigned>>* G, unsigned t, unsigned x, std::set<unsigned> R) {
  std::set<unsigned> P;
  unsigned n = G->size();
  std::vector<unsigned> dist(n, INF), pre(n, INF);
  std::queue<unsigned> que;
  dist[t] = 0;
  que.push(t);
  while (!que.empty()) {
    unsigned u = que.front();
    que.pop();
    for (auto v : (*G)[u])
      if (dist[v] == INF && !R.count(v)) {
	dist[v] = dist[u] + 1;
	que.push(v);
	pre[v] = u;
      }
  }

  if (dist[x] == INF) return P;  
  unsigned v = x;
  // std::cout << t+1 << " -> " << x+1 << ": ";
  while (v != INF) {
    // std::cout << v+1 << " ";
    P.insert(v);
    v = pre[v];
  }
  // std::cout << std::endl;

  return P;
}

bool same_component(std::vector<std::pair<unsigned, unsigned>> E, unsigned s, unsigned t) {
  for (auto e : E)
    if (e.first == s || e.first == t || e.second == s || e.second == t)
      return true;
  return false;
}

void remove_bcc(std::vector<std::set<unsigned> >* G,
		std::vector<std::pair<unsigned, std::vector<std::pair<unsigned, unsigned> > > > &bcc,
		unsigned s, unsigned t) {
  for (auto itr : bcc) {
    if (itr.second.size() == 1) continue;
    if (itr.first == s || itr.first == t) continue;
    if (same_component(itr.second, s, t)) continue;
    auto a = itr.first;
    
    // selecte a vertex in bcc[i] which is not articulation point
    unsigned x = INF;
    for (auto e : itr.second) {
      if (e.first == a) {
	x = e.second;
	break;
      }
      if (e.second == a) {
	x = e.first;
	break;
      }
    }

    std::set<unsigned> E;
    std::set<unsigned> sp1 = shortest_path(G, s, x, E);
    sp1.erase(s), sp1.erase(x);
    std::set<unsigned> sp2 = shortest_path(G, t, x, sp1);
    if (sp2.empty()) {
      // std::cout << a+1 << ": ";
      for (auto e : itr.second) {
       	// std::cout << e.first+1 << "--" << e.second+1 << " ";
	unsigned u = e.first, v = e.second;
	(*G)[u].erase(v);
	(*G)[v].erase(u);
      }
      // std::cout << std::endl;
    }
  }
}

int main()
{
  unsigned n, m, l, s, t;
  std::string line;
  std::vector<std::pair<int, int> > E; // A set of edges (or arcs)
  bool is_digraph = true;
  while (std::getline(std::cin, line)) {
    if ('c' == line[0]) continue;
    else {
      std::stringstream ss(line);
      std::string buf;
      std::vector<std::string> items;
      while (std::getline(ss, buf, ' ')) items.push_back(buf);
      if ('p' == line[0]) {
	n = stoi(items[2]);
	m = stoi(items[3]);
      }
      if ('e' == line[0] || 'a' == line[0]) {
	int u = stoi(items[1]) - 1;
	int v = stoi(items[2]) - 1;
	E.push_back(std::make_pair(u, v));
	if ('e' == line[0]) is_digraph = false;
      }
      if ('l' == line[0]) l = stoi(items[1]);
      if ('t' == line[0]) {
	s = stoi(items[1]) - 1;
	t = stoi(items[2]) - 1;
      }
    }
  }
  
  std::vector<std::set<unsigned> > G(n);
  for (auto e : E) G[e.first].insert(e.second);
  if (!is_digraph) 
    for (auto e : E) G[e.second].insert(e.first);
  
  std::vector<std::pair<unsigned, std::vector<std::pair<unsigned, unsigned> > > > BCC = bcc(&G, s);
  remove_bcc(&G, BCC, s, t);


  /*** remove leaves ***/
  std::set<int> Leaf;
  if (!is_digraph) {
    for (unsigned u = 0; u < n; ++u)
      if (u != s && u != t && G[u].size() == 1)
	Leaf.insert(u);
  }

  for (auto l : Leaf)
    if (G[l].size() > 0) remove_vertex(l, &G, s, t);
  
  /*** contract edges ***/
  
  // for (unsigned u = 0; u < n; ++u)
  //   if (G[u].size() > 0) std::cout << u+1 << std::endl;

  std::vector<std::set<std::pair<unsigned, unsigned> > > wG(n);
  for (unsigned u = 0; u < n; ++u)
    for (auto v : G[u])
      wG[u].insert(std::make_pair(v, 1));
    
  for (unsigned u = 0; u < n; ++u)
    if (wG[u].size() == 2 && u != s && u!= t) contract(u, &wG, s, t);

  // dijkstra
  std::vector<unsigned> from_s(n, 1 << 30);
  std::vector<unsigned> from_t(n, 1 << 30);
  from_s[s] = 0;
  from_t[t] = 0;
  auto cmp = [](const std::pair<unsigned, unsigned>& a,
		const std::pair<unsigned, unsigned>& b) { return a.second > b.second; };
  std::priority_queue<std::pair<unsigned, unsigned>,
		      std::vector<std::pair<unsigned, unsigned>>,
		      decltype(cmp)> que(cmp);

  que.push(std::make_pair(s, 0));
  while (!que.empty()) {
    auto q = que.top();
    if (from_s[q.first] >= q.second) {
      for (const auto& v : wG[q.first]) {
	if (from_s[v.first] > from_s[q.first] + v.second) {
	  from_s[v.first] = from_s[q.first] + v.second;
	  que.push(std::make_pair(v.first, from_s[v.first]));
	}
      }
    }
    que.pop();
  }

  que.push(std::make_pair(t, 0));
  while (!que.empty()) {
    auto q = que.top();
    if (from_t[q.first] >= q.second) {
      for (const auto& v : wG[q.first]) {
	if (from_t[v.first] > from_t[q.first] + v.second) {
	  from_t[v.first] = from_t[q.first] + v.second;
	  que.push(std::make_pair(v.first, from_t[v.first]));
	}
      }
    }
    que.pop();
  }
  
  // create instance
  std::vector<std::set<std::string>> opt(l+1, std::set<std::string>());
  for (int i = 0; i < n; ++i) {
    if (i == t || from_s[i] == (1 << 30)) continue;
    for (const auto& x : wG[i]) {
      int j = x.first;
      if (j == s || from_t[j] == (1 << 30)) continue;
      for (int k = from_s[i]; k <= l-from_t[j]-x.second; ++k) {
	std::ostringstream os;
	for (int a = k+1; a <= k+x.second; ++a) os << "#" << a << " ";
	os << "v" << i+1 << ":" << k << " v" << j+1 << ":" << k+x.second << " p" << k << ":" << i+1 << " p" << k+x.second << ":" << j+1 << " ";
	if (j == t) os << "t";
	opt[k+1].insert(os.str());
	if (i == s) break;
      }
    }
  }
  for (int i = from_s[t]+1; i <= l; ++i) {
    std::ostringstream os;
    for (int j = i; j <= l; ++j) os << "#" << j << " ";
    opt[0].insert(os.str());
  }

  // print
  for (int i = 1; i <= l; ++i)
    std::cout << "#" << i << " ";
  std::cout << "t | ";
  for (int i = 1; i <= n; ++i)
    std::cout << "v" << i << " ";
  for (int i = 0; i <= l; ++i)
    std::cout << "p" << i << " ";
  std::cout << std::endl;

  for (int i = 0; i < opt.size(); ++i) {
    for (auto x : opt[i])
      std::cout << x << std::endl;
  }
  
  // unsigned N = 0, M = 0;
  // for (unsigned u = 0; u < n; ++u) {
  //   if (G[u].size() > 0) N++;
  //   for (auto v : G[u])
  //     if (u < v) M++;
  // }

  // std::cout << "p edge " << N << " " << M << std::endl;
  // for (unsigned u = 0; u < n; ++u) {
  //   for (auto v : G[u])
  //     if (u < v) std::cout << "e " << u+1 << " " << v+1 << std::endl;
  // }

  /*
  if (is_digraph) std::cout << "digraph foo {" << std::endl;
  else std::cout << "graph foo {" << std::endl << std::endl;
  
  std::cout << "  graph [" << std::endl;
  // std::cout << "    overlap = false," << std::endl;
  std::cout << "    layout = fdp" << std::endl;
  std::cout << "  ];" << std::endl << std::endl;

  // std::cout << "  node [" << std::endl;
  // std::cout << "    shape = circle" << std::endl;
  // std::cout << "  ];" << std::endl << std::endl;
  
  // color the terminal vertices
  std::cout << std::endl << "  ";
  std::cout << s+1 << " [" << std::endl;
  std::cout << "    style = \"solid,filled\"," << std::endl;
  std::cout << "    fillcolor = green" << std::endl;
  std::cout << "  ]" << std::endl;

  std::cout << std::endl << "  ";
  std::cout << t+1 << " [" << std::endl;
  std::cout << "    style = \"solid,filled\"," << std::endl;
  std::cout << "    fillcolor = red" << std::endl;
  std::cout << "  ]" << std::endl;

  // draw the weighted edges
  for (unsigned u = 0; u < n; ++u) {
    for (auto v : wG[u])
      if (u < v.first) {
	std::cout << "  " << u+1 << " -- " << v.first+1;
	if (1 < v.second) {
	  std::cout << " [ label = \"";
	  std::cout << v.second;
	  std::cout << "\" ];";
	  std::cout << std::endl;
	}
	else std::cout << ";" << std::endl;
      }
  }
  std::cout << std::endl << "}" << std::endl;

  */
  return 0;
}
